%define libname	libspread
%define pymod 1.5
%define build_python 0

Summary: Multicast Group Communication Framework
Name:    spread
Version: 4.0.0rc2
Release: 1%{?distro_release:.%{distro_release}}
Group:      System/Servers
License: BSD-style
URL:     http://www.spread.org/
Source0: http://www.spread.org/download/spread-src-4.0.0rc2.tar.gz
Source1: http://www.zope.org/Members/tim_one/spread/SpreadModule-%{pymod}/SpreadModule-%{pymod}.tar.bz2
Source2: spread.init.bz2
Source3: spread.sysconfig.bz2
Patch1:     spread-src-4.0.0-mdv_config.diff
BuildRequires: flex
%if %{build_python}
BuildRequires: python-devel
%endif
BuildRoot:  %{_tmppath}/%{name}-%{version}-root

%description
Spread is a toolkit that provides a high performance messaging service that 
is resilient to faults across external or internal networks. Spread 
functions as a unified message bus for distributed applications, and 
provides highly tuned application-level multicast and group communication 
support. Spread services range from reliable message passing to fully 
ordered messages with delivery guarantees, even in case of computer failures 
and network partitions. Spread is designed to encapsulate the challenging 
aspects of asynchronous networks and enable the construction of scalable 
distributed applications, allowing application builders to focus on the 
differentiating components of their application.

%package -n	%{libname}
Summary:	Multicast Group Communication Framework library
Group:          System/Libraries

%description -n	%{libname}
Spread is a toolkit that provides a high performance messaging service that 
is resilient to faults across external or internal networks. Spread 
functions as a unified message bus for distributed applications, and 
provides highly tuned application-level multicast and group communication 
support. Spread services range from reliable message passing to fully 
ordered messages with delivery guarantees, even in case of computer failures 
and network partitions. Spread is designed to encapsulate the challenging 
aspects of asynchronous networks and enable the construction of scalable 
distributed applications, allowing application builders to focus on the 
differentiating components of their application.


%package -n	%{libname}-devel
Summary:	Static library and header files for the libevent library
Group:		Development/C
Obsoletes:	%{name}-devel
Provides:	%{name}-devel
Requires:	%{libname} = %{version}

%description -n	%{libname}-devel
Spread is a toolkit that provides a high performance messaging service that 
is resilient to faults across external or internal networks. Spread 
functions as a unified message bus for distributed applications, and 
provides highly tuned application-level multicast and group communication 
support. Spread services range from reliable message passing to fully 
ordered messages with delivery guarantees, even in case of computer failures 
and network partitions. Spread is designed to encapsulate the challenging 
aspects of asynchronous networks and enable the construction of scalable 
distributed applications, allowing application builders to focus on the 
differentiating components of their application.

This package includes the necessary files to develop systems with Spread.

%if %{build_python}
%package -n	python-spread
Summary:	Python wrapper for Spread client libraries
Group:		Development/Python

%description -n	python-spread
This package contains a simple Python wrapper module for the Spread
toolkit. The wrapper is known to be compatible with Python 2.3 and 2.4.
It may work with earlier Pythons, but this has not been tested.

Spread (www.spread.org) is a group communications package.  You'll
need to download and install it separately.  The Python API has been
built and tested against Spreads 3.16.1 through 3.17.3, although at
least Spread 3.17 is required to use this version of the wrapper.
3.17.3 is recommended.
%endif

%prep

%setup -q -n spread-src-%{version} -a1
%patch1 -p0 -b .mdv_config

bzcat %{SOURCE2} > spread.init
bzcat %{SOURCE3} > spread.sysconfig

%build

%configure

make

%if %{build_python}
pushd SpreadModule-%{pymod}
    python setup.py build_ext -I ../include -L ..
popd
%endif

%install
[ "%{buildroot}" != "/" ] && rm -rf %{buildroot}

mkdir -p %{buildroot}/tmp/docdir
%makeinstall -j1 DOCFILES= docdir=%{buildroot}/tmp/docdir
rm -rf %{buildroot}/tmp/docdir

install -d %{buildroot}%{_sysconfdir}/{sysconfig,logrotate.d}
install -d %{buildroot}%{_initrddir}
install -d %{buildroot}/var/log/spread
install -d %{buildroot}/var/run/spread

install -m0644 docs/sample.spread.access_ip %{buildroot}%{_sysconfdir}/spread.access_ip
install -m0755 spread.init %{buildroot}%{_initrddir}/spread
install -m0644 spread.sysconfig %{buildroot}%{_sysconfdir}/sysconfig/spread

touch %{buildroot}/var/log/spread/spread.log

%if %{build_python}
pushd SpreadModule-%{pymod}
    python setup.py install --root %{buildroot}
popd
%endif

# install log rotation stuff
cat > %{buildroot}%{_sysconfdir}/logrotate.d/spread << EOF
/var/log/spread/spread.log {
    create 644 spread spread
    monthly
    compress
    missingok
    postrotate
	/bin/kill -HUP `cat /var/run/spread/spread.pid 2> /dev/null` 2> /dev/null || true
    endscript
}
EOF

%pre
/usr/sbin/useradd -r -M -s /bin/false -d /var/run/spread -c "spread system user" spread > /dev/null2>&1 || :

%post
if [ ! -f /var/log/spread/spread.log ]; then
  touch /var/log/spread/spread.log
  chown spread.spread /var/log/spread/spread.log
  chmod 0644 /var/log/spread/spread.log
fi

/sbin/chkconfig --add spread
if [ $1 -ne 1 -a -f /var/lock/subsys/spread ]; then
   /sbin/service spread restart
fi

%preun
if [ $1 = 0 ]; then
   /sbin/service spread stop > /dev/null 2>/dev/null || :
   /sbin/chkconfig --del spread
fi

%post -n %{libname} -p /sbin/ldconfig

%postun -n %{libname} -p /sbin/ldconfig

%clean
[ "%{buildroot}" != "/" ] && rm -rf %{buildroot}

%files
%defattr(-,root,root)
%doc CVS_Readme.txt Readme.txt license.txt release_announcemen*txt
%doc docs/TODO docs/PORTING docs/*txt
%doc daemon/Changelog
%attr(0644,root,root) %config(noreplace) %{_sysconfdir}/spread.*
%attr(0644,root,root) %config(noreplace) %{_sysconfdir}/sysconfig/spread
%attr(0644,root,root) %config(noreplace) %{_sysconfdir}/logrotate.d/spread
%attr(0755,root,root) %{_initrddir}/spread
%{_bindir}/sp*
%{_bindir}/flush_user
%{_sbindir}/sp*
%{_mandir}/man1/*
%attr(0755,spread,spread) %dir /var/run/spread
%attr(0755,spread,spread) %dir /var/log/spread
%attr(0644,spread,spread) %ghost /var/log/spread/spread.log

%files -n %{libname}
%defattr(-,root,root)
%{_libdir}/lib*.so.*

%files -n %{libname}-devel
%defattr(-,root,root)
%{_libdir}/lib*.so
%{_libdir}/lib*.a
%{_includedir}/*
%{_mandir}/man3/*

%if %{build_python}
%files -n python-spread
%defattr(-,root,root)
%doc SpreadModule-%{pymod}/CHANGES SpreadModule-%{pymod}/doc.txt SpreadModule-%{pymod}/LICENSE
%doc SpreadModule-%{pymod}/README SpreadModule-%{pymod}/TODO.txt
%{_libdir}/python*/site-packages/*
%endif

%changelog
* Fri Sep 15 2006 Aleksey Nogin <rpm@nogin.org> 4.0.0rc2-0
- Initial Red Hat package (import from Mandriva)
- Upgraded to 4.0.0rc2
- Temporarily disabling the python part (since it does not seem to be
  immediately compatible with 4.0.0) 

* Tue Dec 20 2005 Oden Eriksson <oeriksson@mandriva.com> 3.17.3-1mdk
- initial Mandriva package (conectiva import)
- added P0, P1

* Fri Jan 02 2004 Arnaldo Carvalho de Melo <acme@conectiva.com.br>
+ 2004-01-02 21:07:55 (42885)
- Added some more BuildRequires

* Wed May 14 2003 Ricardo Erbano <erbano@conectiva.com>
+ 2003-05-14 11:27:24 (31128)
- Added the service to ntsysv entry, but disabled by default, see #8232

* Fri Dec 20 2002 Ricardo Erbano <erbano@conectiva.com>
+ 2002-12-20 13:41:57 (20778)
- Added patch file fix_sparc, from acme@conectiva.com.br, closes: #7275
- All packages need to Build it, now are in BuildRequires

* Tue Sep 03 2002 Gustavo Niemeyer <niemeyer@conectiva.com>
+ 2002-09-03 16:14:34 (13662)
- Imported package from snapshot.
